//
//  ResultFaceVC.swift
//  SSSSS
//
//  Created by itsol on 5/15/20.
//  Copyright © 2020 itsol. All rights reserved.
//

import UIKit

class SBKResultFaceVC: UIViewController {
    @IBOutlet weak var imgFace: UIImageView!
    @IBOutlet weak var btnClose: UIButton!
    @IBOutlet weak var btnNext: UIButton!
    @IBOutlet weak var lbDescription: UILabel!
    @IBOutlet weak var lbCopyright: UILabel!
    @IBOutlet weak var imagetest1: UIImageView!
    @IBOutlet weak var imagetest2: UIImageView!
    
    var imageData: Data?
    var dataImageSuccess: [Data] = []
    var idFront: String = ""
    var idBack: String = ""
    var URLToken: String = ""
    var validateImage: Bool = true
    var dataPush: [String:Any]?
    static let shared = SBKResultFaceVC()
    var completionSuccessFaceData: (_ data: [String: Any]?, _ cardImage: Data?, _ faceImage: Data?) -> Void = {_,_,_ in}
    
    override func viewDidLoad() {
        super.viewDidLoad()
    }
    
    func loadConfigUI() {
        //self.lbCopyright.text = Global.copyright
        //self.lbCopyright.textColor = UIColor.colorFromHexa(Global.colorTextPreview)
//        self.btnNext.backgroundColor = UIColor.colorFromHexa(Global.colorButtonNext)
//        self.btnClose.backgroundColor = UIColor.colorFromHexa(Global.colorButtonBack)
//        self.btnNext.setTitleColor(UIColor.colorFromHexa(Global.colorTextButtonNext), for: .normal)
//        self.btnClose.setTitleColor(UIColor.colorFromHexa(Global.colorTextButtonBack), for: .normal)
        if Global.frontConfig == "" {
            //self.lbCopyright.font = UIFont(name: Global.frontConfig, size: 17)
//            self.lbDescription.font = UIFont(name: Global.frontConfig, size: 17)
//            self.btnNext.titleLabel?.font = UIFont(name: Global.frontConfig, size: 17)
//            self.btnClose.titleLabel?.font = UIFont(name: Global.frontConfig, size: 17)
        }
    }
    
    override func viewDidAppear(_ animated: Bool) {
        super.viewDidAppear(animated)
        self.loadConfigUI()
        let imageCap = UIImage(data: imageData!)
        self.imgFace.layer.cornerRadius = 8
        
        let scale = imgFace.frame.width / imageCap!.size.width
        let cropImage = self.cropImage(image: imageCap!, rect: CGRect(x: imageCap!.size.width / 10, y: imageCap!.size.height / 10, width: self.imgFace.frame.width, height: self.imgFace.frame.height ), scale: scale)
        if Global.typeFace == "TAKEPHOTO" {
            self.imgFace.image = cropImage
        } else {
            self.imgFace.image = imageCap
        }
//        btnNext.setTitle("Confirm my selfie".localized(), for: .normal)
//        btnClose.setTitle("Take a new selfie".localized(), for: .normal)
        lbDescription.text = "Make sure your selfie clearly shows your face".localized()
    }
    
    //Xử lý ảnh hiển thị
    func cropImage(image: UIImage, rect: CGRect, scale: CGFloat) -> UIImage? {
        let imageCap = UIImage(data: imageData!)
        
        let widthCrop = imageCap!.size.width - imageCap!.size.width / 4
        
        UIGraphicsBeginImageContextWithOptions(CGSize(width: widthCrop, height: (imageCap!.size.width - imageCap!.size.width / 3) * 4 / 3), true, 0.0)
        image.draw(at: CGPoint(x: -rect.origin.x / scale, y: -rect.origin.y / scale))
        let croppedImage = UIGraphicsGetImageFromCurrentImageContext()
        UIGraphicsEndImageContext()
        return croppedImage
    }
    
    init() {
        super.init(nibName: "SBKResultFaceVC", bundle: Bundle(for: SBKResultFaceVC.self))
    }
          
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    //Chuyển sang màn hình kết quả
    @IBAction func onNext(_ sender: Any) {
            Loading.shared.showLoading(viewMain: self)
            SBOCRRequest.shared.processFace(image: self.imgFace.image!.pngData()! , pathURL: Global.url_face, idBack: self.idBack, idFront: self.idFront) {(errorCode,data) -> Void in
                Loading.shared.hideLoading(viewMain: self)
                guard errorCode == nil else {
                    DispatchQueue.main.async {
                        self.lbDescription.textColor = UIColor.red
                        self.lbDescription.text = "Server error".localized()
                    }
                    return
                }
                DispatchQueue.main.async {
                    self.completionSuccessFaceData(data!, Global.imageCard1, self.imgFace.image!.pngData()!)
                }
            }
    }
    
    //quay về màn chụp mặt
    @IBAction func onBack(_ sender: Any) {
        self.navigationController?.popViewController(animated: true)
    }
    
    @IBAction func onSelectBackTop(_ sender: Any) {
        for controller in self.navigationController!.viewControllers as Array {
            if controller.isKind(of: SBKCaptureCardVC.self) {
                self.navigationController!.popToViewController(controller, animated: true)
                break
            }
        }
    }
}
