//
//  ResultCapture.swift
//
//  Created by itsol on 5/11/20.
//  Copyright © 2020 itsol. All rights reserved.
//

import UIKit

class SBKResultCapture: UIViewController {
    @IBOutlet weak var imgPhotoCard: UIImageView!
    public var imageData: Data?
    public var dataCrop: Data?
    @IBOutlet weak var btnNext: UIButton!
    @IBOutlet weak var btnClose: UIButton!
    @IBOutlet weak var lbDescription: UILabel!
    @IBOutlet weak var lbCopyright: UILabel!
    
    var statusScreen: String = "vertical"
    var checkScreen: Int = 1
    var idFront: String = ""
    var idBack: String = ""
    var URLToken: String = ""
    var completionSuccessResultCard: (_ data: [String: Any]?, _ cardImage: Data?, _ faceImage: Data?) -> Void = {_,_,_ in}
    
    override func viewDidLoad() {
        super.viewDidLoad()
    }
    
    init() {
        super.init(nibName: "SBKResultCapture", bundle: Bundle(for: SBKResultCapture.self))
    }
    
    func loadConfigUI() {
        //self.lbCopyright.text = Global.copyright
        //self.lbCopyright.textColor = UIColor.colorFromHexa(Global.colorTextPreview)
        //self.lbDescription.textColor = UIColor.colorFromHexa(Global.colorTextPreview)
        //self.btnNext.backgroundColor = UIColor.colorFromHexa(Global.colorButtonNext)
        //self.btnClose.backgroundColor = UIColor.colorFromHexa(Global.colorButtonBack)
        //self.btnNext.setTitleColor(UIColor.colorFromHexa(Global.colorTextButtonNext), for: .normal)
        //self.btnClose.setTitleColor(UIColor.colorFromHexa(Global.colorTextButtonBack), for: .normal)
        if Global.frontConfig == "" {
//            self.lbCopyright.font = UIFont(name: Global.frontConfig, size: 17)
//            self.lbDescription.font = UIFont(name: Global.frontConfig, size: 17)
//            self.btnNext.titleLabel?.font = UIFont(name: Global.frontConfig, size: 17)
//            self.btnClose.titleLabel?.font = UIFont(name: Global.frontConfig, size: 17)
        }
        //btnNext.setTitle("My license is readable".localized() , for: .normal)
       // btnClose.setTitle("Take a new picture".localized(), for: .normal)
        lbDescription.text = "Make sure your license details are clear to read, with no blur or glare".localized()
    }
    
    override func viewDidAppear(_ animated: Bool) {
        super.viewDidAppear(animated)
        self.loadConfigUI()
        let imageCap = UIImage(data: imageData!)
        
        let scale = imgPhotoCard.frame.width / imageCap!.size.width
        var cropImage: UIImage?
        
        if UIDevice.current.userInterfaceIdiom == .pad {
            cropImage = SBKValidateInput.shared.cropImageHorizontal(image: imageCap!, rect: CGRect(x: imageCap!.size.width * 1 / 10, y: imageCap!.size.height * 3 / 20, width: imageCap!.size.width * 8 / 10, height: imageCap!.size.height * 8 / 10), scale: 1.0)!.rotate(radians: .pi / 2)
        } else {
            cropImage = self.cropImage(image: imageCap!, rect: CGRect(x: imageCap!.size.width / 20, y: imageCap!.size.height / 8 + imageCap!.size.height / 50, width: imageCap!.size.width * 18 / 20, height: imageCap!.size.width * 18 / 20 * 3 / 4 ), scale: scale)
        }
        
        dataCrop = cropImage!.pngData()
        self.imgPhotoCard.image = cropImage
    }
          
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }

    //Xử lý ảnh hiển thị
    func cropImage(image: UIImage, rect: CGRect, scale: CGFloat) -> UIImage? {
        UIGraphicsBeginImageContextWithOptions(CGSize(width: rect.width, height: rect.height), true, 0.0)
        image.draw(at: CGPoint(x: -rect.origin.x , y: -rect.origin.y ))
        let croppedImage = UIGraphicsGetImageFromCurrentImageContext()
        UIGraphicsEndImageContext()
        return croppedImage
    }
    
    func navigateToFace() {
        DispatchQueue.main.async {
            if Global.typeFace == "TAKEPHOTO" {
                let viewControllers = SBKTutorialFaceVC()
                viewControllers.idFront = self.idFront
                viewControllers.idBack = self.idBack
                viewControllers.URLToken = self.URLToken
                    
                viewControllers.completionSuccessTutorialFace = { [weak self] data, cardImage, faceImage in
                    guard let `self` = self else { return }
                    self.completionSuccessResultCard(data, cardImage, faceImage)
                }
                self.navigationController?.pushViewController(viewControllers, animated: true)
            } else {
                let viewControllers = SBKRecordFace()
                viewControllers.idFront = self.idFront
                viewControllers.idBack = self.idBack
                viewControllers.URLToken = self.URLToken

                viewControllers.completionSuccessFaceRecord = { [weak self] data, cardImage, faceImage in
                    guard let `self` = self else { return }
                    self.completionSuccessResultCard(data, cardImage, faceImage)
                }
                self.navigationController?.pushViewController(viewControllers, animated: true)
            }
        }
    }
    
    //validate ảnh, gửi resquest
    @IBAction func onResquest(_ sender: Any) {
        if self.checkScreen == 1 {
            
            Global.imageCard1 = dataCrop!
            if Global.step == "ALL" {
                DispatchQueue.main.async {
                    let viewControllers = SBKCaptureCardVC()
                    viewControllers.descriptionScreen = "Back of your personal card".localized()
                    viewControllers.checkScreen = 2
                    viewControllers.idFront = self.idFront
                    viewControllers.URLToken = self.URLToken
                                
                    viewControllers.completionSuccessCard = { [weak self] data, cardImage, faceImage in
                        guard let `self` = self else { return }
                        self.completionSuccessResultCard(data, cardImage, faceImage)
                    }
                                
                    self.navigationController?.pushViewController(viewControllers, animated: true)
                }
            } else {
                    self.navigateToFace()
            }
            } else {
                Global.imageCard2 = dataCrop!
                self.navigateToFace()
        }
    }
    
    //quay về màn hình chụp
    @IBAction func onBack(_ sender: Any) {
        self.navigationController?.popViewController(animated: true)
    }
    
    @IBAction func onSelectBackTop(_ sender: Any) {
        for controller in self.navigationController!.viewControllers as Array {
            if controller.isKind(of: SBKCaptureCardVC.self) {
                self.navigationController!.popToViewController(controller, animated: true)
                break
            }
        }
    }
    
}

extension UIImage {
    func rotate(radians: Float) -> UIImage? {
        var newSize = CGRect(origin: CGPoint.zero, size: self.size).applying(CGAffineTransform(rotationAngle: CGFloat(radians))).size
        // Trim off the extremely small float value to prevent core graphics from rounding it up
        newSize.width = floor(newSize.width)
        newSize.height = floor(newSize.height)

        UIGraphicsBeginImageContextWithOptions(newSize, false, self.scale)
        let context = UIGraphicsGetCurrentContext()!

        // Move origin to middle
        context.translateBy(x: newSize.width/2, y: newSize.height/2)
        // Rotate around middle
        context.rotate(by: CGFloat(radians))
        // Draw the image at its center
        self.draw(in: CGRect(x: -self.size.width/2, y: -self.size.height/2, width: self.size.width, height: self.size.height))

        let newImage = UIGraphicsGetImageFromCurrentImageContext()
        UIGraphicsEndImageContext()

        return newImage
    }
}
