//
//  TutorialFaceVC.swift
//  SSSSS
//
//  Created by itsol on 5/15/20.
//  Copyright © 2020 itsol. All rights reserved.
//

import UIKit

class SBKTutorialFaceVC: UIViewController {
    @IBOutlet weak var brightLight: UILabel!
    @IBOutlet weak var lbNoHat: UILabel!
    @IBOutlet weak var lbNoGlasses: UILabel!
    @IBOutlet weak var btnNext: UIButton!
    
    var idFront: String = ""
    var idBack: String = ""
    var URLToken: String = ""
    var completionSuccessTutorialFace: (_ data: [String: Any]?, _ cardImage: Data?, _ faceImage: Data?) -> Void = {_,_,_ in}

    override func viewDidLoad() {
        super.viewDidLoad()
        
        //Cài đặt button Back
        var image = UIImage(named: "back", in: Bundle(for: SBKTutorialVC.self), compatibleWith: nil)
        image = image?.withRenderingMode(.alwaysOriginal)
        
        let button = UIButton(type: .system)
        button.setImage(image, for: .normal)
        button.setTitle("Back".localized(), for: .normal)
        button.sizeToFit()
        button.imageEdgeInsets.left = -5
        button.setTitleColor(UIColor.black, for: .normal)
        button.addTarget(self, action: #selector(self.back), for: .touchUpInside)
        
        let newBackButton = UIBarButtonItem(customView: button)
        self.navigationItem.leftBarButtonItem = newBackButton
    }
    
    //Xử lý back màn hình
    @objc func back(sender: UIBarButtonItem) {
        for controller in self.navigationController!.viewControllers as Array {
            if controller.isKind(of: SBKCaptureCardVC.self) {
                self.navigationController!.popToViewController(controller, animated: true)
                break
            }
        }
    }
    
    override func viewDidAppear(_ animated: Bool) {
        self.lbNoHat.text = "No Hat".localized()
        self.lbNoGlasses.text = "No Glasses".localized()
        self.brightLight.text = "Bright Light".localized()
       // self.btnNext.setTitle("Proceed to Take Selfie".localized(), for: .normal)
        //self.btnNext.backgroundColor = UIColor.colorFromHexa(Global.colorButtonTutorial)
    }
    
    init() {
        super.init(nibName: "SBKTutorialFaceVC", bundle: Bundle(for: SBKTutorialFaceVC.self))
    }
       
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }

    //Chuyển sang màn hình chụp mặt
    @IBAction func onStart(_ sender: Any) {
        DispatchQueue.main.async {
            let viewControllers = SBKCaptureFaceVC()
            viewControllers.idFront = self.idFront
            viewControllers.idBack = self.idBack
            viewControllers.URLToken = self.URLToken
            
            viewControllers.completionSuccessFace = { [weak self] data, cardImage, faceImage in
                guard let `self` = self else { return }
                self.completionSuccessTutorialFace(data, cardImage, faceImage)
            }
            
            self.navigationController?.pushViewController(viewControllers, animated: true)
        }
    }
}
