//
//  ExtUiViewController.swift
//  OCR-SDK
//
//  Created by itsol on 5/18/20.
//  Copyright © 2020 itsol. All rights reserved.
//

import Foundation
import UIKit

extension UIViewController {
    
    //Hiển thị thông báo
    //input: message: String
    func showToast(message : String) {
        let toastLabel = UILabel(frame: CGRect(x: self.view.frame.size.width/2 - 75, y: self.view.frame.size.height-100, width: 150, height: 35))
        toastLabel.backgroundColor = UIColor.black.withAlphaComponent(0.6)
        toastLabel.textColor = UIColor.white
        toastLabel.textAlignment = .center;
        toastLabel.font = UIFont(name: "Montserrat-Light", size: 12.0)
        toastLabel.text = message
        toastLabel.alpha = 1.0
        toastLabel.layer.cornerRadius = 10;
        toastLabel.clipsToBounds  =  true
        self.view.addSubview(toastLabel)
        UIView.animate(withDuration: 4.0, delay: 0.1, options: .curveEaseOut, animations: {
            toastLabel.alpha = 0.0
        }, completion: {(isCompleted) in
            toastLabel.removeFromSuperview()
        })
    }
    
    //kiểm tra ảnh sau khi chụp
    //input: image: Data
    //output: Bool
    func validateImage(image: Data) -> Bool {
        return true
    }
}
