//
//  Loadding.swift
//  OCR-SDK
//
//  Created by itsol on 5/18/20.
//  Copyright © 2020 itsol. All rights reserved.
//

import Foundation
import UIKit

class Loading {
    static let shared = Loading()
    var loadingView = UIView()
    var activityIndicator = UIActivityIndicatorView()
    
    func showLoading(viewMain: UIViewController) {
        DispatchQueue.main.async {
            self.loadingView = UIView(frame: viewMain.view.frame)
            self.loadingView.tag = 999999
            self.loadingView.backgroundColor = UIColor.gray.withAlphaComponent(0.5)
            self.activityIndicator.style = .white
            self.activityIndicator.center = self.loadingView.center
            self.activityIndicator.startAnimating()
            self.loadingView.addSubview(self.activityIndicator)
            viewMain.view.addSubview(self.loadingView)
        }
    }
        
    func hideLoading(viewMain: UIViewController){
        DispatchQueue.main.async {
            UIView.animate(withDuration: 0.0, delay: 1.0, options: .curveEaseOut, animations: {
                self.loadingView.alpha = 0.0
                self.activityIndicator.stopAnimating()
            }, completion: { finished in
                self.activityIndicator.removeFromSuperview()
                self.loadingView.removeFromSuperview()
                let removeView  = viewMain.view.viewWithTag(999999)
                removeView?.removeFromSuperview()
            })
        }}
}
